// Screen Space Noise Effect
//
// Noise EFfect
// Pat 'Hawthorne' Shearon
// pat.shearon@gmail.com www.theregulators.org
// http://www.truevision3d.com/forums/printpage.html;topic=18745.0
//
// This version is provided under a Creative Commons Attribution 3.0 License
// http://creativecommons.org/licenses/by/3.0/ 

//transforms
float4x4 tW: WORLD;        //the models world matrix
float4x4 tV: VIEW;         //view matrix as set via Renderer (EX9)
float4x4 tP: PROJECTION;   //projection matrix as set via Renderer (EX9)
float4x4 tWVP: WORLDVIEWPROJECTION;

//float
float Timer : TIME;


//texture
texture Tex <string uiname="Texture";>;
sampler Texture = sampler_state    //sampler for doing the texture-lookup
{
    Texture   = (Tex);          //apply a texture to the sampler
    MipFilter = LINEAR;         //sampler states
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    AddressU = Wrap;
    AddressV = Wrap;
};

float4x4 tTex: TEXTUREMATRIX <string uiname="Texture Transform";>;

// Input and Output Semantics 
struct VS_INPUT 
{ 
   float4 position : POSITION; 
   float2 texCoord : TEXCOORD; 
}; 
struct VS_OUTPUT 
{ 
   float4 position : POSITION; 
   float2 texCoord : TEXCOORD;    
}; 
#define PS_INPUT VS_OUTPUT 

//Vertex Shader Output
VS_OUTPUT vs_main(const VS_INPUT IN)
{
   VS_OUTPUT OUT;

   OUT.position = mul(IN.position, tWVP);
   OUT.texCoord = mul(IN.texCoord, tTex);

   return OUT;
}

// Pixel Shader Output
float4 ps_main( float2 Tex : TEXCOORD0  ) : COLOR0 
{ 
	float2 t = Tex;		
	float x=t.x*t.y*123456 * Timer;
	x=fmod(x,13) * fmod(x,123);	
	float dx = fmod(x,0.01);
	float dy = fmod(x,0.012);
	float4 c=tex2D(Texture, t+float2(dx,dy));
	return c;
} 

//Technique Calls
technique PostProcess 
{ 
   pass Pass_0 
   { 
      VertexShader = compile vs_1_1 vs_main(); 
      PixelShader = compile ps_2_0 ps_main(); 
   } 
}
